; Fast enough signed 8-bit multiply routine
; by Chris Williams <cow3.14@juno.com>
; 2004 May 12
; Redistribution: use this routine as you wish.

; input:
; 	E and H = operands
; output:
; 	HL = E*H (signed)
; This could be made slightly faster by separating the positive and negative
; shift-and-add paths.

mulsAxH:
	ld	e,a
mulsExH:
	xor	a
	ld	l,a	; initial result
	sla	h	; get sign bit
	jr	nc,.hpos
	jr	z,.special	; H = -128 (special case)
	sub	e
	ld	e,a	; E = -E
	xor	a
	sub	h
	inc	a	; H was shifted left so this is to add one more
	ld	h,a	; H = -H
.hpos
	ld	a,e
	add	a,a
	sbc	a,a
	ld	d,a	; DE = E (sign extended)
 repeat 6
	add	hl,hl
	jr	nc,$+3
	add	hl,de
 endr
	add	hl,hl
	ret	nc
	add	hl,de
	ret

.special	; multiply E by -128 (-E << 7)
	xor	a
	ld	l,a
	sub	e
	sra	a
	ld	h,a
	rr	l
	ret
